Subject: RE: [mobile-ip] Issues with the S bit.

From: "KASSI-LAHLOU Mohammed FTRD/DMI/CAE" <[email-masked]>
Date: Wed, 4 Dec 2002 10:32:02 +0100

Hi folks,

A mobile node can have several providers and thus it can have several
Home Agents, one per provider. So the mobile node has several home
networks. In this case, when the mobile node is in one of its home
networks it is considered in its home network for this network and in a
visited network for the other home networks. It must use its home
address in this network as a care-of address when it sends BU to its
Home Agents on the other home networks.
We will propose a draft to specify this case of use

Kassi

-----Message d'origine-----
De : Vijay Devarapalli [mailto:[email-masked]]
Envoye : mardi 3 decembre 2002 21:24
A : Greg O'Shea
Cc : Mobile IPv6 mailling list
Objet : Re: [mobile-ip] Issues with the S bit.

hi Greg,

> Greg O'Shea wrote:
> 
> I have some questions concerning the S bit in Binding Updates of
> Section 6.1.7 and 10.3.1. I have no real experience of using this
> feature, which appeared sometime post draft 13,

it was called the prefix length field before. it used to be a fixed
8 bit length field in the BU. if the prefix length field is non-zero 
it is the same as setting the 'S' bit to 0. instead of using 8 bits, 
it was replaced by the 'S' bit.

> 1.  A mobile node has potentially several Home Agents each potentially
> offering several routing prefixes for home agent service. We cannot
> assume that these sets of routing prefixes are distinct, or if they
> are, that they won't change such that they suddenly intersect. Assume
> that the MN is using the same IFId for all its Home Agents. Now, when
> the MN moves it sends BU+S+D to several HA 

??? several HAs? why is the MN using more than one HA at a time?"
maybe I am ignorant, but I cant figure out why the MN would use
multiple home agents. anyway, in the implementations I have seen
so far, the MN at any time uses only one home agent.

Vijay

---

From: "KASSI-LAHLOU Mohammed FTRD/DMI/CAE" <[email-masked]>
Date: Thu, 5 Dec 2002 14:41:09 +0100

Hi,

I agree that it is legit per the MIP draft and an informational draft
will make it more explicit. Then let explain the proposal with an
example.

Suppose an MN that has 2 home networks HN1 and HN2 and configured with 2
home addresses respectively h@1 in HN1 and h@2 in HN2 (may be on the
same interface or on 2 interfaces). A mobile node has one home agent HA1
on HN1 and one home agent HA2 on HN2.

                         +--------------------------+ 
                         |         IP network       |
                         +/------------|-----------\+
                         /             |            \
                     FN /              | HN2         \ HN1
                    +--/--+         +--|--+        +--\--+
                    | RA  |         | HA2 |        | HA1 |
                    +-----+         +-----+        +-----+
 
                                                      +----+
                                                      | MN |
                                                      +----+

- When the MN is connected to HN1 it is on its home network (HN1) but it
can also send a BU to its HA2 on HN2 using h@1 as care-of address. Thus
the HA2 tunnels datagramms (with DA=h@2) for delivery to the MN. (vice
versa when the MN is connected to HN2)

- When the MN is connected to FN (foreign network) it acquires a care-of
address on this network and it sends BUs to HA1 and HA2. Thus the HA1
and HA2 tunnel datagramms (with respectively DA=h@1 and DA=h@2) for
delivery to the MN.

Kassi

PS: this has no relation with the S bit issue and it was in response to
the question about several HAs.

-----Message d'origine-----
De : Behcet Sarikaya [mailto:[email-masked]]
Envoye : mercredi 4 decembre 2002 20:36
A : Greg O'Shea
Cc : KASSI-LAHLOU Mohammed FTRD/DMI/CAE; Vijay Devarapalli; Mobile IPv6
mailling list

I agree with Vijay. I do not understand Kassi's mail, see below.

Greg O'Shea wrote:

I agree. I do not think the IPv6 world should design to be constrained
to a single [provider|interface|(Home)address|HomeAgent].

I think multi-home agent is entirely legit per the existing draft, but
clearly an informational draft would be a good idea at this time. At the
moment the only obvious glitch I've noticed is the S-bit. Do you know of
any more?

Greg
  
-----Original Message-----
From: KASSI-LAHLOU Mohammed FTRD/DMI/CAE 
[mailto:[email-masked]] 
Sent: 04 December 2002 09:32
To: Vijay Devarapalli; Greg O'Shea
Cc: Mobile IPv6 mailling list
Subject: RE: [mobile-ip] Issues with the S bit.

Hi folks,

A mobile node can have several providers and thus it can have 
several Home Agents, one per provider. So the mobile node has 
several home networks. In this case, when the mobile node is 
in one of its home networks it is considered in its home 
network for this network and in a visited network for the 
other home networks. It must use its home address in this 
network as a care-of address when it sends BU to its Home 
Agents on the other home networks. We will propose a draft to 
specify this case of use

Kassi
    
It is not clear what what you mean by HAs? There is supposed to be a
single HA.
There could be HAs, but one in each visited network, that is called MAP,
see HMIPv6 draft.

-----Message d'origine-----
De : Vijay Devarapalli [mailto:[email-masked]]
Envoye : mardi 3 decembre 2002 21:24
A : Greg O'Shea
Cc : Mobile IPv6 mailling list
Objet : Re: [mobile-ip] Issues with the S bit.

hi Greg,

Greg O'Shea wrote:

it was called the prefix length field before. it used to be a 
fixed 8 bit length field in the BU. if the prefix length field 
is non-zero 
it is the same as setting the 'S' bit to 0. instead of using 8 bits, 
it was replaced by the 'S' bit.

1.  A mobile node has potentially several Home Agents each 
      
potentially 
    
offering several routing prefixes for home agent service. We cannot 
assume that these sets of routing prefixes are distinct, or if they 
are, that they won't change such that they suddenly 
      
intersect. Assume 
    
that the MN is using the same IFId for all its Home Agents. 
      
Now, when 

??? several HAs? why is the MN using more than one HA at a 
time?" maybe I am ignorant, but I cant figure out why the MN 
would use multiple home agents. anyway, in the implementations 
I have seen so far, the MN at any time uses only one home agent.

Vijay

-- 
Behcet

---

From: "Greg O'Shea" <[email-masked]>
Date: Fri, 6 Dec 2002 08:59:01 -0000

>    "In this case, the mobile node MUST NOT attempt to
>     re-use the same home address. 

In general I do not think it is meaningful to talk of "the same home
address" with the s bit. With the s bit you are trying to register a set
of #n HoA, n>0, in a single transaction and, given existing BA syntax,
in the event of failure the MN cannot tell which of the (2^n)-1 subsets
failed. Maybe "the same home address" wasn't in the failing subset. If
the s-failure semantics are "all or nothing" then in the event of
s-failure then the MN could presumably enumerate the entire set and
attempt register each member individually, including "the same home
address". Wouldn't it make more sense to say

"In this case, the mobile node MUST NOT attempt to re-use the s bit."

This is the simple stuff by the way. Intersections between s bit
generated sets is where things really start to get complicated, per my
original email.

>From: Vijay Devarapalli [mailto:[email-masked]] 
>Sent: 05 December 2002 22:15
>To: Jari Arkko
>Cc: Greg O'Shea; KASSI-LAHLOU Mohammed FTRD/DMI/CAE; Mobile 
>IPv6 mailling list
>Subject: Re: [mobile-ip] Issues with the S bit.
>
>
>Jari Arkko wrote:
>> 
>> Section 11.7.1 says:
>> 
>>    "In this case, the mobile node MUST NOT attempt to
>>     re-use the same home address.  It SHOULD continue to
>>     register care-of addresses for its other home addresses,
>>     if any."
>> 
>> Perhaps this should then be changed to
>> 
>>    "In this case, the mobile node MUST NOT attempt to
>>     re-use the same home address. The mobile node MAY
>>     retry the registration with the Single Address Only (S)
>>     bit set to 1, if the bit was set to 0 on the failed attempt.
>>     The mobile node SHOULD continue to register care-of
>>     addresses for its other home addresses, if any."
>
>yes. this looks good.
>
>> Beyond this, we have the following items of disagreement:
>> 
>> - Can a MN have several independent HAs? I think personally
>>    yes because IPv6 allows multiple addresses?
>
>yes. but not more than one per home link. basically the MN 
>should avoid asking two home agents on the same link to defend 
>its addresses at the same time.
>
>> - To remove the S bit?
>
>no.
>
>> - Or to make the S bit optional in the HA? I think the spec will
>>    become more complicated with this, we need error codes and
>>    new text to handle various conditions. I say we either keep
>>    the S bit or throw it away, but not make it optional... I hate
>>    optional features.
>
>I agree. making it optional is a bad idea.
>
>> - Need for stating the assumptions behind prefixes and multiple
>>    HAs? I think we need to state something about complete success
>>    or failure of S=0 BUs.
>
>I thought we already did this. if not we should. I prefer the 
>all or nothing approach. otherwise the implementation becomes 
>too complicated.
>
>> - Whether or not the MN should stick to the home agent it has
>>    selected? I think it should, need to look at the text to
>>    see if it is clear enough now. But apparently not.
>
>I think the MN should stick to one home agent as long as the 
>existing bindings are still valid. this should be clarified.
>
>Vijay
>

---

From: "Krishna Kumar" <[email-masked]>
Date: Fri, 6 Dec 2002 15:22:39 -0800

Hi Jari,

>>>Hmm... here's an idea: why don't we require that if multiple
>>>home agents are being used, the S-bit will be set to 1. This
>>>would make sure that there is no problem, even if the mobile node
>>>wouldn't know if the two home agents it has happen to be on the
>>>same link. Remember that there could be different prefixes.
>>
>>
>> no Jari. as long as the MN is using only one home agent per
>> home link at any time, there is *no* problem. it can set the
>> 'S' bit to 0 even though there are multiple home agents on
>> the home link.
>
>Yes, but let me clarify my proposal. If the *mobile node* intends
>to use multiple HAs simultaneously, *then* it MUST use S=1.

I had a problem with your clarification itself, as I sent earlier
(basically my earlier mail below) :

> Hmm... here's an idea: why don't we require that if multiple
> home agents are being used, the S-bit will be set to 1. This
> would make sure that there is no problem, even if the mobile node
> wouldn't know if the two home agents it has happen to be on the
> same link. Remember that there could be different prefixes.

I don't see how this way of setting S=1 would work. If multiple agents
on the same link provide different prefixes, the MN cannot decide which HA
to send which address with S=1. It cannot send all addresses to 'n' agents
since they may not support prefixes that don't intersect, on the other
hand for prefixes that intersect, DAD would fail for those addresses on
possibly all HA's.

While I agree the 'S' bit is useful to have, there seems to be another
problem with using it when there are multiple home agents supplying
different prefixes (ofcourse I believe that only one HA is being used
for the BU). Suppose the MN sends the BU with S=0 to one HA, the HA does
DAD only on those prefixes that are onlink on the link the Home Address
is valid. Hence it will not do DAD on other prefixes that are supported
only by other HA's. Hence using 'S' bit doesn't work in this case, it is
not just a case of bad behaviour in case of conflict as per original
Greg's mail, but an incomplete protection ?

A solution to all these can be considered by Jari's (I think ??) earlier
suggestion of DHAAD reply having more stateful information about links/
prefixes. But then the MN planning to use S=0 MUST do DHAAD before it can
send a BU, even if it is configured with a home agent.

thanks,

- KK

>> if the MN is planning to use more than home agent at the same
>> time, then it probably makes sense introducing the above
>> requirement. nobody has yet made a case for the MN using more
>> than one home agent per home link simultaneously. and if we go
>> with what is written in section 11.4.1, it is already prohibited.
>> we are trying to find a solution to a problem that does not
>> exist, IMO.
>
>You have a point there. OTOH IPv6 in general allows multiple
>addresses, routers etc, and I think the language in 11.4.1 is vague
>about 'home link'; I could interprete it also as allowing potentially
>multiple home links and respective home addresses and agents.
>